//
//  PDF2on1  2y[W1y[WɕϊvO
//      by K.Miki
//   2011/01/26 ver. 1.00
//   2018/10/09 ver. 1.10 E
//   2018/10/11 ver. 1.11 
//

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.Panel;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.dnd.DnDConstants;
import java.awt.dnd.DropTarget;
import java.awt.dnd.DropTargetAdapter;
import java.awt.dnd.DropTargetDropEvent;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JProgressBar;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.filechooser.FileNameExtensionFilter;

import com.itextpdf.kernel.geom.PageSize;
import com.itextpdf.kernel.geom.Rectangle;
import com.itextpdf.kernel.pdf.PdfDocument;
import com.itextpdf.kernel.pdf.PdfPage;
import com.itextpdf.kernel.pdf.PdfReader;
import com.itextpdf.kernel.pdf.PdfWriter;
import com.itextpdf.io.source.OutputStream;
import com.itextpdf.kernel.pdf.canvas.PdfCanvas;
import com.itextpdf.kernel.pdf.xobject.PdfFormXObject;
import com.itextpdf.kernel.color.Color;
import com.itextpdf.kernel.color.DeviceCmyk;

public class PDF2on1 extends JFrame implements ActionListener{
  static JButton button1, button2;
  static JTextField tfw,tfp;
  static String fpath, cwidth;
  static File cpath = new File("");
  static JRadioButton rbauto = new JRadioButton("", true);
  static JRadioButton rblr = new JRadioButton("E");
  static JRadioButton rbrl = new JRadioButton("E");
  static JRadioButton rbud = new JRadioButton("㉺");
  static JRadioButton rbdu = new JRadioButton("");
  static JCheckBox cbsave  = new JCheckBox("ۑmF");
  static JCheckBox cbfirst = new JCheckBox("擪y[WƗ");
  static JCheckBox cbframe = new JCheckBox("gt");
  static JProgressBar pbar = new JProgressBar(1, 100);

  public static void main(String[] args) {
	readini();
    PDF2on1 frame = new PDF2on1();
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    frame.setBounds(10, 10, 400, 270);
    frame.setTitle("PDF 2 on 1");
	frame.setLocationRelativeTo(null);
    DropTarget dtarget = new DropTarget(button1,new dtAdapter());
	if (args.length==2) {
	   twoOnOne(args[0],args[1]);
	   System.exit(0);
	} else if (args.length==1) {
	   if (cbsave.isSelected()) frame.setVisible(true);
	   twoOnOne(args[0],saveTo(args[0]));
	   System.exit(0);
    } else frame.setVisible(true);
  }

  // Drag & Dropւ̑Ή
  private static class dtAdapter extends DropTargetAdapter {
	 public void drop(DropTargetDropEvent dtde) {
        try {
           Transferable trans = dtde.getTransferable();
           DataFlavor flavors[] = trans.getTransferDataFlavors();
           for (int i = 0; i < flavors.length; ++i)
              if (flavors[i].isFlavorJavaFileListType()) {
				 dtde.acceptDrop(DnDConstants.ACTION_COPY_OR_MOVE);
                 java.util.List list = (java.util.List) trans.getTransferData(flavors[i]);
                 for (int j = 0; j < list.size(); ++j) {
                    File file = (File) list.get(j);
		            twoOnOne(file.getAbsolutePath(),saveTo(file.getAbsolutePath()));
                 }
              }
        } catch (IOException ioe) {
	       ioe.printStackTrace();
        } catch (UnsupportedFlavorException ufe) {
           ufe.printStackTrace();
        } finally {
           dtde.dropComplete(true);
        }
     }
  }

  // ݒWindow̕\
  PDF2on1(){
    getContentPane().setLayout(new GridLayout(8,1));

    button1=new JButton("t@CJ (܂͂Drug & Drop)");
    button1.addActionListener(this);
    getContentPane().add(button1);

	Panel p3=new Panel();
    p3.setLayout(new GridLayout(1,3));
    JLabel lab3=new JLabel();
	lab3.setText("@y[W̍̕");
	p3.add(lab3);
	ButtonGroup bg = new ButtonGroup();
	bg.add(rbauto);bg.add(rblr);bg.add(rbrl);bg.add(rbud);bg.add(rbdu);
    Panel p31=new Panel();
    p31.setLayout(new GridLayout(1,3));
	p31.add(rbauto);
	p3.add(p31);
	p3.add(new Panel());
    getContentPane().add(p3);

	Panel p7=new Panel();
    p7.setLayout(new GridLayout(1,3));
    JLabel lab7=new JLabel();
	p7.add(lab7);
    Panel p71=new Panel();
    p71.setLayout(new GridLayout(1,2));
	p71.add(rblr);p71.add(rbrl);
	p7.add(p71);
    Panel p72=new Panel();
    p72.setLayout(new GridLayout(1,2));
	p72.add(rbud);p72.add(rbdu);
	p7.add(p72);
    getContentPane().add(p7);

	Panel p1=new Panel();
    p1.setLayout(new GridLayout(1,3));
    JLabel lab1 = new JLabel();
	lab1.setText("@Ԃ̋󂫂̕");
	p1.add(lab1);
	tfw = new JTextField(cwidth, 15);
	p1.add(tfw);p1.add(new Panel());
    getContentPane().add(p1);

	Panel p2=new Panel();
    p2.setLayout(new GridLayout(1,3));
    JLabel lab2=new JLabel();
	lab2.setText("@ۑtH_");
	p2.add(lab2);
	tfp=new JTextField(fpath, 64);
	p2.add(tfp);p2.add(new Panel());
    getContentPane().add(p2);

	Panel p4=new Panel();
    p4.setLayout(new FlowLayout());
	p4.add(cbfirst);p4.add(cbframe);p4.add(cbsave);
    getContentPane().add(p4);

	Panel p6=new Panel();
    p6.setLayout(new FlowLayout());
    button2=new JButton("ݒۑ");
    button2.addActionListener(this);
    button2.setPreferredSize(new Dimension(120,20));
	p6.add(button2);
    getContentPane().add(p6);

	Panel p5=new Panel();
    p5.setLayout(new FlowLayout());
	JLabel lab4=new JLabel();
	lab4.setText("   ver. 1.11  by K.Miki 2018/10/11");
	pbar.setValue(0);
    pbar.setPreferredSize(new Dimension(120,20));
	p5.add(pbar);p5.add(lab4);
    getContentPane().add(p5);
  }

  // ۑ߂
  static String saveTo(String fname){
 	JFileChooser fchooser;
  	File ofile,pfile;
  	int i;

  	if (cbsave.isSelected()) { /* ۑq˂ */
       if (cpath.getPath().equals("")) fchooser = new JFileChooser();
	   else                            fchooser = new JFileChooser(cpath);
       if (fchooser.showSaveDialog(null)==JFileChooser.APPROVE_OPTION){
          fname=fchooser.getSelectedFile().getPath();
       } else
	      fname="";
  	} else { /* ۑ掩w */
	   ofile=new File(fname);
	   if (ofile.getParent()==null) {
	   	  fname=(new File(".").getAbsoluteFile().getParent())+File.separator+fname;
	   }
	   if (!tfp.getText().equals("")) { /* ۑtH_[̎w肠 */
	      ofile=new File(fname);
		  pfile=new File(ofile.getParent()+File.separator+tfp.getText());
		  if (!pfile.exists()) pfile.mkdir();
		  if (tfp.getText().substring(tfp.getText().length()-1)==File.separator)
		     fname=ofile.getParent()+File.separator+tfp.getText()+ofile.getName();
		  else
		     fname=ofile.getParent()+File.separator+tfp.getText()+File.separator+ofile.getName();
	   }
	   ofile=new File(fname);
	   while (ofile.exists()) {
	      i=fname.lastIndexOf(".pdf");
		  fname=fname.substring(0,i)+"2.pdf";
		  ofile=new File(fname);
	   }
  	}
  	return (fname);
  }

  // ۂ̎dƂ iText̃Tv()̃pN
  static void twoOnOne(String fname, String sname) {
  	 int n,i,dir;
 	 float width,height,space=Float.valueOf(tfw.getText());
	 boolean waku=cbframe.isSelected();
	 PageSize ps;
     PdfCanvas canvas;
     PdfFormXObject page1, page2;

	 if (sname.equals("")) return;
	 if (rbauto.isSelected())    dir=1; /* auto       */
	 else if (rblr.isSelected()) dir=2; /* left-rigth */
	 else if (rbrl.isSelected()) dir=3; /* right-left */
	 else if (rbud.isSelected()) dir=4; /* up-dow     */
	 else                        dir=5; /* down-up    */
     try {
    	 PdfDocument pdfr=new PdfDocument(new PdfReader(fname));
         n=pdfr.getNumberOfPages();
        com.itextpdf.kernel.geom.Rectangle psize = pdfr.getFirstPage().getPageSize();
        width = psize.getWidth();
        height = psize.getHeight();
		if (dir==1) {
		   if (width>height) dir=4;
		   else              dir=2;
		}
		if (dir<4) ps = new PageSize(width*2+space, height);
		else       ps = new PageSize(width, height*2+space);
   	    PdfDocument pdfw=new PdfDocument(new PdfWriter(sname));
		pbar.setMaximum(n);pbar.setValue(0);pbar.paintImmediately(pbar.getVisibleRect());
        Color lineColor = new DeviceCmyk(0.0f, 0.0f, 0.0f, 1.0f);
		Rectangle lbox = new Rectangle(0, 0, width, height);
		Rectangle rbox = new Rectangle(width+space, 0, width, height);
        for (i=0;i<n;) {
		   pdfw.setDefaultPageSize(ps);
           i++;pbar.setValue(i);pbar.paintImmediately(pbar.getVisibleRect());
           canvas = new PdfCanvas(pdfw.addNewPage());
           page1 = pdfr.getPage(i).copyAsFormXObject(pdfw);
		   if (dir==2 || dir==5) { /* left & lower*/
			  canvas.addXObject(page1, 0, 0);
	          if (waku) {
                 canvas.setStrokeColor(lineColor)
				       .rectangle(lbox)
                       .closePathStroke();
		      }
		   } else if (dir==3) { /* right */
			  canvas.addXObject(page1, width+space, 0);
	          if (waku) {
                 canvas.setStrokeColor(lineColor)
				       .rectangle(rbox)
                       .closePathStroke();
		      }
		   } else if (dir==4) { /* upper */
			  canvas.addXObject(page1, 0, height+space);
	          if (waku) {
                 canvas.setStrokeColor(lineColor)
				       .rectangle(0, height+space, width, height*2+space)
                       .closePathStroke();
		      }
		   }
		   if (i==1 && cbfirst.isSelected()) continue;
           if (i < n) {
              i++;pbar.setValue(i);pbar.paintImmediately(pbar.getVisibleRect());
              page2 = pdfr.getPage(i).copyAsFormXObject(pdfw);
			  if (dir==2) { /* right */
			     canvas.addXObject(page2, width+space, 0);
			     if (waku) {
                    canvas.setStrokeColor(lineColor)
				       .rectangle(rbox)
                       .closePathStroke();
			     }
			  } else if (dir==3 || dir==4) { /* left or lower */
			     canvas.addXObject(page2, 0, 0);
			     if (waku) {
                    canvas.setStrokeColor(lineColor)
				       .rectangle(lbox)
                       .closePathStroke();
			     }
			  } else { /* upper */
			     canvas.addXObject(page2, 0, height+space);
			     if (waku) {
                    canvas.setStrokeColor(lineColor)
		 		       .rectangle(0, height+space, width, height*2+space)
                       .closePathStroke();
			     }
			  }
           }
        }
        pdfr.close();
        pdfw.close();
     } catch (Exception de) {
        de.printStackTrace();
     }
  }

  //  ut@CJv{^Ɓuݒۑv{^ւ̑Ή
  public void actionPerformed(ActionEvent e){
     if (e.getSource().equals(button1)) { /* t@CJ */
	 	JFileChooser fchooser;
        if (cpath.getPath().equals("")) fchooser = new JFileChooser();
		else                            fchooser = new JFileChooser(cpath);
        javax.swing.filechooser.FileFilter filter1=new FileNameExtensionFilter("PDF document (*.pdf)","pdf");
        fchooser.addChoosableFileFilter(filter1);
        if (fchooser.showOpenDialog(this)==JFileChooser.APPROVE_OPTION){
		   cpath=fchooser.getCurrentDirectory();
           twoOnOne(fchooser.getSelectedFile().getPath(),saveTo(fchooser.getSelectedFile().getPath()));
        }
    } else if (e.getSource().equals(button2)) { /* ݒ̕ۑ */
	   try {
          File file=new File("PDF2on1.ini");
          FileWriter fw=new FileWriter(file);
		  fw.write("[PDF2on1ini]\r\n");
		  fw.write("width="+tfw.getText()+"\r\n");
		  fw.write("path="+tfp.getText()+"\r\n");
		  if (rbauto.isSelected())    fw.write("direction=auto\r\n");
		  else if (rblr.isSelected()) fw.write("direction=leftRight\r\n");
		  else                        fw.write("direction=upDown\r\n");
		  if (cbsave.isSelected()) fw.write("confirm=yes\r\n");
		  else                     fw.write("confirm=no\r\n");
		  if (cbfirst.isSelected()) fw.write("first=only\r\n");
		  if (cbframe.isSelected()) fw.write("frame=yes\r\n");
		  else                      fw.write("frame=no\r\n");
          fw.close();
       } catch(IOException ioe){
		  JOptionPane.showMessageDialog(this,ioe,"ݒ̕ۑł܂" ,
			JOptionPane.INFORMATION_MESSAGE);
       }
    }
  }

  // ݒt@C̓ǂݍ
  static void readini() {
     try {
        FileReader in = new FileReader("PDF2on1.ini");
        BufferedReader br = new BufferedReader(in);
        String line;
		fpath="";cwidth="";cbfirst.setSelected(false);
        while ((line = br.readLine()) != null) {
           if (line.indexOf("path=")==0) fpath=line.substring(5).trim();
           if (line.indexOf("width=")==0) cwidth=line.substring(6).trim();
		   if (line.indexOf("direction=auto")==0) {
		   	  rbauto.setSelected(true);
		   	  rblr.setSelected(false);
		   	  rbud.setSelected(false);
		   }
		   if (line.indexOf("direction=leftRight")==0) {
		   	  rbauto.setSelected(false);
		   	  rblr.setSelected(true);
		   	  rbud.setSelected(false);
		   }
		   if (line.indexOf("direction=upDown")==0) {
		   	  rbauto.setSelected(false);
		   	  rblr.setSelected(false);
		   	  rbud.setSelected(true);
		   }
           if (line.indexOf("confirm=yes")==0) cbsave.setSelected(true);
           if (line.indexOf("confirm=no")==0)  cbsave.setSelected(false);
           if (line.indexOf("first=only")==0) cbfirst.setSelected(true);
           if (line.indexOf("frame=yes")==0) cbframe.setSelected(true);
           if (line.indexOf("frame=no")==0) cbframe.setSelected(false);
        }
        br.close();
        in.close();
		if (fpath.equals("")) fpath="trans";
		if (cwidth.equals("")) cwidth="30";
    } catch (IOException e) {
        fpath="trans";
		cwidth="30";
    }
  }
}
